--- Mi PSP para FISHELL

ID006MP.cfg_.title = getText("titulo",ID006MP)
ID006MP.cfg_.multiLoad = true
ID006MP.cfg_.title_for_accs = getText("titulo",ID006MP)
ID006MP.path = "ms0:/FISHELL/APP/ID006MP"
---------------------------------------------------------------
---------------------------------------------------------------

ID006MP.img_pc = image.load(ID006MP.path.."/src/pc.png")
ID006MP.img_original_by_zerozelta = image.load("ms0:/FISHELL/IMG/SYSTEM/by_zerozelta.png")
ID006MP.img_panel = image.load(ID006MP.path.."/src/panel.png")
ID006MP.img_foco = image.load(ID006MP.path.."/src/foco.png")

ID006MP.img_bar1 = image.load(ID006MP.path.."/src/bar1.png")
ID006MP.img_bar2 = image.load(ID006MP.path.."/src/bar2.png")

ID006MP.img_actualizar = image.load(ID006MP.path.."/src/actualizar.png")

ID006MP.crono = timer.new()

--[[ FUNCIONES BASICAS ]]--

function ID006MP.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
ID006MP.reload(id)
ID006MP.crono:start()
end

function ID006MP.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--

if puntero.isOver(sdk.x + 7,sdk.y + 9,195,47) then
	ID006MP.img_foco:blit(sdk.x + 7,sdk.y + 9)
	puntero.overOn("popup_link")
	if control.press("menu") then
		ID006MP.makePopup_ms()
	end
	
	if control.press("select") then
		launch.custom("ms0:/")
	end
end

if puntero.isOver(sdk.x + 210,sdk.y + 9,195,47) then
	ID006MP.img_foco:blit(sdk.x + 210,sdk.y + 9)
	puntero.overOn("popup_link")
	if control.press("menu") then
		ID006MP.makePopup_umd()
	end
	
	if control.press("select") then
		launch.umd()
	end 
end

ID006MP.img_panel:blit(sdk.x,sdk.y)

ID006MP.img_bar1:blit(sdk.x + 7 + (195 - 130),sdk.y + 9 + (47 - 21))
ID006MP.img_bar2:blit(sdk.x + 7 + (195 - 130),sdk.y + 9 + (47 - 21),0,0,id.freeSpace_ms_barsize,18)
screen.print(sdk.x + 14 + (195 - 130),sdk.y + 9 + (47 - 21) + 4,id.MSgastada.." / "..id.MStotal,0.5,color.new(30,30,30),color.new(255,255,255,200),"scroll_left",115)

sdk.cristalEffect(2,sdk.h - 48,459,46,90)

ID006MP.img_pc:blit(sdk.x + 4,sdk.h + sdk.y - 53)
ID006MP.img_original_by_zerozelta:blend(sdk.w + sdk.x + 3 - 71,sdk.h + sdk.y - 45)

screen.print(sdk.x + 82,sdk.y + 17,"PSP".." (ms0:/)",0.6,color.new(0,0,0),color.new(255,255,255,200))
screen.print(sdk.x + 270,sdk.y + 17,"UMD (disc0:/)",0.6,color.new(0,0,0),color.new(255,255,255,200))
if id.isUMD then
	screen.print(sdk.x + 270,sdk.y + 30,getText("disponible",ID006MP),0.5,color.new(0,0,0),color.new(255,255,255,200))
else
	screen.print(sdk.x + 270,sdk.y + 30,getText("no encontrado",ID006MP),0.5,color.new(0,0,0),color.new(255,255,255,200))
end

screen.print(sdk.x + 12,sdk.y + 74,getText("ram total",ID006MP)..": "..id.RAM_total,0.5,color.new(0,0,0),0x0)
screen.print(sdk.x + 12,sdk.y + 84,getText("ram libre",ID006MP)..": "..id.RAM_porcent.." %",0.5,color.new(0,0,0),0x0)
screen.print(sdk.x + 12,sdk.y + 104,getText("cpu",ID006MP)..": "..id.CPU.."/333",0.5,color.new(0,0,0),0x0)
screen.print(sdk.x + 12,sdk.y + 114,getText("fps",ID006MP)..": "..id.fps,0.5,color.new(0,0,0),0x0)
screen.print(sdk.x + 12,sdk.y + 124,getText("bateria",ID006MP)..": "..id.bateria.." %",0.5,color.new(0,0,0),0x0)

ID006MP.drawBar(sdk.x + 100,sdk.y + 84,color.new(46,147,212),100,id.RAM_porcent)
ID006MP.drawBar(sdk.x + 100,sdk.y + 104,color.new(46,147,212),333,id.CPU)
ID006MP.drawBar(sdk.x + 100,sdk.y + 114,color.new(46,147,212),120,id.fps)
ID006MP.drawBar(sdk.x + 100,sdk.y + 124,color.new(46,147,212),100,id.bateria)

screen.print(sdk.x + 180,sdk.y + 74,getText("capacidad ms",ID006MP)..": "..id.MStotal,0.5,color.new(0,0,0),0x0)
screen.print(sdk.x + 180,sdk.y + 84,getText("espacio libre",ID006MP)..": "..id.MSfree,0.5,color.new(0,0,0),0x0)
screen.print(sdk.x + 180,sdk.y + 94,getText("espacio gastado",ID006MP)..": "..id.MSgastada,0.5,color.new(0,0,0),0x0)
if batt.charging() then
	screen.print(sdk.x + 180,sdk.y + 114,getText("tiempo bateria",ID006MP)..": ".."+++".." ("..getText("cargando").."...)",0.5,color.new(0,0,0),0x0)
else
	screen.print(sdk.x + 180,sdk.y + 114,getText("tiempo bateria",ID006MP)..": "..batt.time().." "..getText("minutos",ID006MP),0.5,color.new(0,0,0),0x0)
end
screen.print(sdk.x + 180,sdk.y + 124,getText("tiempo iniciado fishell",ID006MP)..": "..math.floor(os.clock() / 60).." "..getText("minutos",ID006MP),0.5,color.new(0,0,0),0x0)

ID006MP.drawBar(sdk.x + 180 + 200,sdk.y + 84,color.new(46,147,212),100,id.MSPfree)
ID006MP.drawBar(sdk.x + 180 + 200,sdk.y + 94,color.new(232,38,38),100,id.MSPgastado)

screen.print(sdk.x + 4 + 55,sdk.h + sdk.y - 43,getText("fishell 1.0 revicion",ID006MP).." "..system.version,0.5,color.new(255,255,255),color.new(140,140,140))
screen.print(sdk.x + 4 + 55,sdk.h + sdk.y - 43 + 12,getText("nick del psp",ID006MP)..": "..id.nick,0.5,color.new(255,255,255),color.new(140,140,140))
screen.print(sdk.x + 4 + 55,sdk.h + sdk.y - 43 + 24,getText("cuenta de fishell",ID006MP)..": "..LOG_USER,0.5,color.new(255,255,255),color.new(140,140,140))

ID006MP.img_actualizar:blend(sdk.x + sdk.w - 50,sdk.y + 10,140)
if puntero.isOver(sdk.x + sdk.w - 50,sdk.y + 10,36,36) then
	puntero.overOn("link")
	ID006MP.img_actualizar:blend(sdk.x + sdk.w - 50,sdk.y + 10,255)
	if control.press("select") then
		ID006MP.reload(id)
	end
end

if ID006MP.crono:time() > (1000 * 3) then
	ID006MP.crono:reset()
	ID006MP.reload(id)
end

end

function ID006MP.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--

end

function ID006MP.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID006MP.makePopup_ms()
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }

eleme = {}
eleme[1] = { texto = getText("crear accs",ID006MP) , accion = "descktop.makeAccsDir(\"MS0:/\",\"imagen\",\"FOLDER\",\"ms0:/\")" , est = true }
eleme[2] = { texto = getText("renombrar dispositivo",ID006MP) , accion = "" , est = false }

popup.setElements(eleme)
popup.activate()
end

function ID006MP.makePopup_umd(id,archivo)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }

local eleme = {}
eleme[1] = { texto = getText("lanzar umd",ID006MP) , accion = "launch.umd()" , est = true }
eleme[2] = { texto = getText("dumpear umd") , accion = "launch.dump_umd()" , est = true }
eleme[3] = { texto = getText("crear accs",ID006MP) , accion = "descktop.makeAccsDir(\"Lanzar UMD\",\"umd\",\"CHUNK\",\"launch.umd()\")" , est = true }
eleme[4] = { texto = getText("acceso umd",ID006MP) , accion = "descktop.makeAccsDir(\"Dump UMD\",\"umd_dump\",\"CHUNK\",\"launch.dump_umd()\")" , est = true }

popup.setElements(eleme)
popup.activate()
end

function ID006MP.reload(id)
id.nick = os.nick()
id.RAM_porcent = math.floor((os.getfreememory() * 100 ) / os.getinitmemory())
id.RAM_total = files.sizeformat(os.getinitmemory())
id.CPU = os.cpu()
id.fps = screen.fps()
id.freeSpace_ms_p = (files.freespace() * 100 ) / files.totalspace()
id.freeSpace_ms_barsize = (125 / 100) * (100 - id.freeSpace_ms_p)
id.bateria = batt.percent()
id.isUMD = umd.present()
id.MStotal = files.sizeformat(files.totalspace())
id.MSfree = files.sizeformat(files.freespace())
id.MSgastada = files.sizeformat(files.totalspace() - files.freespace())
id.MSPfree = id.freeSpace_ms_p
id.MSPgastado = ((files.totalspace() - files.freespace()) * 100 ) / files.totalspace()

if id.MSPgastado < 0 or id.MSPgastado > 100 then id.MSPgastado = 100 end
if id.MSPfree < 0 or id.MSPfree > 100 then id.MSPfree = 100 end

end

function ID006MP.drawBar(x,y,color_p,valor100,valorx)
	local porcent = math.floor((valorx * 100 ) / valor100)
	local drawporcent = math.floor((porcent / 100) * 60)
	draw.fillrect(x + 1,y,drawporcent - 1,10,color_p)
	draw.rect(x,y,60,10,color.new(0,0,0))
end