----------_se inicia el id de la aplicacion_----------
ID007TA = {}
------------------------------------------------------

--[[Aqui se configuran las caracteristicas de la aplicacion]]--
ID007TA.cfg_ = {}
ID007TA.cfg_.title = "Lista de Programas y funciones"
ID007TA.cfg_.title_for_accs = "Programas"
ID007TA.cfg_.multiLoad = false
ID007TA.path = "ms0:/FISHELL/APP/ID007TA/"
---------------------------------------------------------------
---------------------------------------------------------------

ID007TA.img_pstbar = image.load(ID007TA.path.."src/pst_bar.png")
ID007TA.img_pstfocus = image.load(ID007TA.path.."src/pst_focus.png")
ID007TA.img_pstnofocus = image.load(ID007TA.path.."src/pst_nofocus.png")
ID007TA.img_listbar = image.load(ID007TA.path.."src/list_bar.png")
ID007TA.img_pstfocusover = image.load(ID007TA.path.."src/pst_focus_over.png")

system.dofile(ID007TA.path.."src/programs.lua")
system.dofile(ID007TA.path.."src/functions.lua")
system.dofile(ID007TA.path.."src/portals.lua")

--[[ FUNCIONES BASICAS ]]--

function ID007TA.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
	ID007TA.initProgramas(id)
end

function ID007TA.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--
	ID007TA.drawPst(id)
	
	if id.pestana == "programas" then
		ID007TA.drawPrograms(id)
	end
	
	if id.pestana == "funciones" then
		ID007TA.drawFunctions(id)
	end
	
	if id.pestana == "portales" then
		ID007TA.drawPortals(id)
	end
	
end

function ID007TA.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--
	tmp_id007ta = nil
end

function ID007TA.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

---------------------------
---------------------------
---------------------------

function ID007TA.drawPst(id)
	ID007TA.img_pstnofocus:blit(sdk.x + 2,sdk.y + 2)
	ID007TA.img_pstnofocus:blit(sdk.x + 131,sdk.y + 2)
	ID007TA.img_pstnofocus:blit(sdk.x + 260,sdk.y + 2)
	
	ID007TA.img_pstbar:blit(sdk.x + 2,sdk.y + 22)
	
	if id.pestana == "programas" then
		ID007TA.img_pstfocus:blit(sdk.x + 2,sdk.y + 2)
	end
	
	if id.pestana == "portales" then
		ID007TA.img_pstfocus:blit(sdk.x + 131,sdk.y + 2)
	end
	
	if id.pestana == "funciones" then
		ID007TA.img_pstfocus:blit(sdk.x + 260,sdk.y + 2)
	end
	
	screen.print(sdk.x + 10,sdk.y + 8,"Aplicaciones",0.55,color.new(30,30,30),color.new(255,255,255,150))
	screen.print(sdk.x + 139,sdk.y + 8,"Portales",0.55,color.new(30,30,30),color.new(255,255,255,150))
	screen.print(sdk.x + 269,sdk.y + 8	,"Funciones",0.55,color.new(30,30,30),color.new(255,255,255,150))
	
	if puntero.isOver(sdk.x + 2,sdk.y + 2,128,21) then
		puntero.overOn("link")
		if control.press("select") then
			ID007TA.changePst(id,"programas")
		end
	end
	
	if puntero.isOver(sdk.x + 131,sdk.y + 2,128,21) then
		puntero.overOn("link")
		if control.press("select") then
			ID007TA.changePst(id,"portales")
		end
	end
	
	if puntero.isOver(sdk.x + 260,sdk.y + 2,128,21) then
		puntero.overOn("link")
		if control.press("select") then
			ID007TA.changePst(id,"funciones")
		end
	end
end

function ID007TA.changePst(id,pst)
		if pst == "programas" then
			ID007TA.initProgramas(id)
			return
		end
		
		if pst == "funciones" then
			ID007TA.initFunctions(id)
			return
		end
		
		if pst == "portales" then
			ID007TA.initPortals(id) ----- cambiar
			return
		end
end
