---- GADGET: relog

GADGET_ID01RA = {}
GADGET_ID01RA.path = "ms0:/FISHELL/GADGETS/ID01RA/"
GADGET_ID01RA.modelo = "B1"
GADGET_ID01RA.crono = 20

GADGET_ID01RA.img_background = image.load(GADGET_ID01RA.path.."models/"..GADGET_ID01RA.modelo.."_backg.png")
GADGET_ID01RA.min = image.load(GADGET_ID01RA.path.."models/"..GADGET_ID01RA.modelo.."_min.png")
GADGET_ID01RA.hor = image.load(GADGET_ID01RA.path.."models/"..GADGET_ID01RA.modelo.."_hor.png")
GADGET_ID01RA.seg = image.load(GADGET_ID01RA.path.."models/"..GADGET_ID01RA.modelo.."_seg.png")

function GADGET_ID01RA.run(x,y,trans)
GADGET_ID01RA.img_background:blend(x,y,trans)

if GADGET_ID01RA.crono == 0 then
	GADGET_ID01RA.seg:rotate(0,0,GADGET_ID01RA.getPos("%S",60))
	GADGET_ID01RA.min:rotate(0,0,GADGET_ID01RA.getPos("%M",60))
	GADGET_ID01RA.hor:rotate(0,0,GADGET_ID01RA.getPos("%I",12))
	GADGET_ID01RA.crono = 20
else
	GADGET_ID01RA.crono = GADGET_ID01RA.crono - 1
end

GADGET_ID01RA.seg:blend(x + 32,y + 37,trans)
GADGET_ID01RA.min:blend(x + 32,y + 37,trans)
GADGET_ID01RA.hor:blend(x + 32,y + 37,trans)
end

function GADGET_ID01RA.getPos(formato,limite)
local tiempo = os.date(formato)
tiempo = tonumber(tiempo)
if tiempo == nil then return 0 end

local tiempo_grados = ((100 / limite) * tiempo)
tiempo_grados = math.floor((360 / 100) * tiempo_grados)
return tiempo_grados + 180
end