----[[ MODULO GADGETS ]]----
-- Gestion de los gadgets de escritorio
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com
-- 64 * 74

gadget = {}
gadget.posx = 480 - 67
gadget.install = {}

--gadget.img_ejemplo = image.load(LOG_THEME_PATH.."CUSTOM/desck/ejemplo.png")

function gadget.draw(input)

if #gadget.install == 0 then 
	gadget.draw_zero(input)
	return
end

local trans = descktop.trans_accs

if descktop.isChange ~= false then 
	trans = 255
else
	if descktop.finishCange == false then
		trans = 255
		if descktop.trans_accs >= 255 then
			descktop.finishCange = true
		end
	end
end

gadget.posx = gadget.posx - 5

if descktop.focoin == "window" and input ~= nil then
	gadget.posx = (480) + sdk.x
	trans = input
end


if gadget.posx > 480 then gadget.posx = 480 end
if gadget.posx < 480 - 67 then gadget.posx = 480 - 67 end

if trans <= 0 then
	gadget.posx = 480
	return
end

gadget.img_panel:blend(gadget.posx,0,trans)
--gadget.img_ejemplo:blend(gadget.posx,0,trans)

for i = 1,#gadget.install do
	gadget.play(gadget.install[i],i,trans)
end

end

function gadget.play(obj,pos,trans)
	local x = gadget.posx + 3
	local y = 4 + ((pos - 1) * 74)
	
	if puntero.isOver(x,y,64,74) then
	
		puntero.overOn("popup")
		
		if control.press("menu") then
			gadget.mkpopup(obj.index)
		end
		
		if kernel.isPopup == false then
			gadget.img_focus:blend(x,y,trans)
		end
	end
		
	assert(loadstring(obj.variable..".run("..x..","..y..","..trans..")"))();
end

function gadget.load()
if files.exists(LOG_PATH.."gadgets.ini") == false then return end

local txt = uld.filesRead(LOG_PATH.."gadgets.ini")
local file = string.explode(txt[1],":-:")
local nums = 0

for i = 1,table.maxn(file) do
	file[i] = tostring(file[i])
	if files.exists("ms0:/FISHELL/GADGETS/"..file[i].."/") then
		system.dofile("ms0:/FISHELL/GADGETS/"..file[i].."/gadget.lua")
		nums = nums + 1
		table.insert(gadget.install,{id = file[i] , variable = "GADGET_"..file[i] , index = #gadget.install + 1 })
	end
	
	if nums == 3 then break end
end

if nums > 0 then
	gadget.img_panel = image.load(LOG_THEME_PATH.."CUSTOM/desck/gadget_bar.png")
	gadget.img_focus = image.create(64,74,color.new(255,255,255,120))
end

end

function gadget.mkpopup(index) 
	local popupval = {}
	local thispopup = loadstring("return "..gadget.install[index].variable..".popup_component")();
	
	if thispopup ~= nil then
		table.insert(popupval,thispopup)
	end
	
	
	table.insert(popupval,{texto = getText("cambiar gadget") , accion = "" , est = true , accionToClose = true })
	table.insert(popupval,{texto = getText("quitar gadget") , accion = "" , est = true , accionToClose = true })
	
	descktop.focusinpopup = 0
	popup.setElements(popupval)
	popup.activate()
end

function gadget.draw_zero(input)

local trans = descktop.trans_accs

if descktop.isChange ~= false then 
	trans = 255
else
	if descktop.finishCange == false then
		trans = 255
		if descktop.trans_accs >= 255 then
			descktop.finishCange = true
		end
	end
end

gadget.posx = gadget.posx - 5

if descktop.focoin == "window" and input ~= nil then
	gadget.posx = (480) + sdk.x
	trans = input
end

if gadget.posx > 480 then gadget.posx = 480 end
if gadget.posx < 480 - 67 then gadget.posx = 480 - 67 end

if trans <= 0 then
	gadget.posx = 480
	return
end

if puntero.isOver(gadget.posx + 2,4,65,222) then
	gadget.img_panel_disabled:blend(gadget.posx,0,trans)
else
	gadget.img_panel_disabled:blend(gadget.posx,0,trans - 80)
end

end

gadget.load()

if #gadget.install == 0 then
	gadget.img_panel_disabled = image.load(LOG_THEME_PATH.."CUSTOM/desck/gadget_bar_disabled.png")
end