----- Portal selector de archivos -----

--[[
	FILE_SELECTOR_TYPE = ["folders"] ["files"] ["all"] -- odo de seleccion
	FILE_SELECTOR_FILTER = { "formatos" } -- filtro de archivos
	FILE_SELECTOR_NAME_FILTER = "Nombre del filtro" -- Nombre asignado al filtro por defecto "* todos los archivos"
	FILE_SELECTOR_INIT_PATH = "Ruta de inicio" -- ruta con la que comienza el explorador
	FILE_SELECTOR_MULTIPLE_INTERVAL = [true] [false] -- Seleccion por multiples intervalos
	FILE_SELECTOR_ROOT_ENABLED =  [true] [false] -- Permite la seleccion de la raiz
]]--

--[[
	FILE_SELECTOR_TYPE = 
	FILE_SELECTOR_FILTER = 
	FILE_SELECTOR_NAME_FILTER = 
	FILE_SELECTOR_INIT_PATH = 
	FILE_SELECTOR_MULTIPLE_INTERVAL =
	FILE_SELECTOR_ROOT_ENABLED = 
--]]

portal.app_path = "ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR"
portal.img_window = image.load("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR/src/window.png")
portal.img_dir = image.load("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR/src/folder.png")
portal.img_file = image.load("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR/src/file.png")

	portal.opciones = {}
	--table.insert(portal.opciones,)
	table.insert(portal.opciones,{name = getText("cancelar seleccion") , chunk = "portal.open = false" })
	table.insert(portal.opciones,{name = getText("ir a la raiz") , chunk = "" })
	
	if system.isGO then
		table.insert(portal.opciones,{name = getText("cambiar de memoria").."(ef0:)" , chunk = "" })
	end
	
	table.insert(portal.opciones,{name = getText("copiar ruta archivo"), chunk = "" })
	table.insert(portal.opciones,{name = getText("Copiar nombre archivo") , chunk = "" })
	
if scrollbar == nil then
	system.dofile("ms0:/FISHELL/SRC/SDK/scrollbar.lua")
end

if FILE_SELECTOR_TYPE == nil then
	FILE_SELECTOR_TYPE = "all"
end

if FILE_SELECTOR_NAME_FILTER == nil then
	FILE_SELECTOR_NAME_FILTER = "( * All Files )"
end

if FILE_SELECTOR_MULTIPLE_INTERVAL == nil then
	FILE_SELECTOR_MULTIPLE_INTERVAL = false
end

if FILE_SELECTOR_ROOT_ENABLED == nil then 
	FILE_SELECTOR_ROOT_ENABLED = false
end

if FILE_SELECTOR_INIT_PATH == nil then
	FILE_SELECTOR_INIT_PATH = "ms0:/"
else
	FILE_SELECTOR_INIT_PATH = tostring(FILE_SELECTOR_INIT_PATH)
end

portal.scrollbar = scrollbar.new(458,39,182,1,1)

function portal.loadDir(ruta)
	if ruta == nil then ruta = "ms0:/" end
	
	if files.exists(ruta) == false then
		ruta = "ms0:/"
	end
	
	portal.files = nil
	portal.files = {}
	portal.files = portal.getFileslist(ruta)
	portal.ruta = ruta
	portal.lista = 1
	portal.totallistas = #portal.files
	portal.foco = 1
	portal.seleccion = 0
	portal.focus_y = 41
end

function portal.draw(trans)
	portal.img_screen:blit(0,0)
	portal.img_window:blend(0,0,trans)
	
	screen.print(22,228,"Nombre: ",0.5,color.new(0,0,0,trans),0x0)
	screen.print(25,228 + 17,FILE_SELECTOR_NAME_FILTER,0.5,color.new(80,80,80,trans),0x0,"scroll_right",358 + 40)
	screen.print(49,23,portal.ruta,0.5,color.new(0,0,0,trans),0x0,"scroll_right",407)
	
	if #portal.files == 0 then 
		screen.print(20,41,"No hay archivos en esta carpeta",0.5,color.new(0,0,0,trans),0x0)
	end
	
	if portal.files[portal.foco] ~= nil then
		screen.print(98,228,files.nopath(portal.files[portal.foco].name),0.5,color.new(0,0,0,trans),0x0,"scroll_right",358)
	end
	
	local i = 1
	for j = portal.lista,portal.lista + 7 do
	
		local x = 17
		local y = 41 + ((i - 1) * 22)
		
		if portal.files[j] == nil then break end
		if portal.files[i] == nil then break end
	
		if portal.seleccion == j then 
			draw.fillrect(x,y,440,20,color.new(243,231,0,trans - 140))
			draw.rect(x,y,440,20,color.new(233,221,0,trans))
		end
		
		if portal.foco == j then
			if portal.focus_y > y then portal.focus_y = portal.focus_y - 2 end
			if portal.focus_y < y then portal.focus_y = portal.focus_y + 2 end
		
			if portal.seleccion == j and portal.focus_y == y then
			
			else
				draw.fillrect(x,portal.focus_y,440,20,color.new(75,143,196,trans - 140))
				draw.rect(x,portal.focus_y,440,20,color.new(75,143,196,trans))
			end
		end
		
		if portal.files[j].directory == true then
			portal.img_dir:blend(x + 3,y,trans)
			screen.print(385,y + 5,"[FOLDER]",0.6,color.new(20,20,20,trans),color.new(255,255,255,trans))
		else
			portal.img_file:blend(x + 3,y,trans)
			screen.print(385,y + 5,files.sizeformat(portal.files[j].size),0.6,color.new(20,20,20,trans),color.new(255,255,255,trans))
		end
		
		screen.print(x + 28,y + 5,files.nopath(portal.files[j].name),0.6,color.new(20,20,20,trans),color.new(255,255,255,trans))
		
		i = i + 1
	end
	
	scrollbar.setVal(portal.scrollbar,portal.foco,portal.totallistas)
	scrollbar.draw(portal.scrollbar,trans)

	system.runPortalKernel({ home = false })
	--- screen.flip()
	
	if control.press("menu") then
		portal.drawactions()
	end
	
	if controls.press("down") then
		portal.foco = portal.foco + 1
		
		if portal.foco > 1 + portal.lista + 5 and portal.foco ~= #portal.files then
			portal.lista = portal.lista + 1
			
			if portal.lista > #portal.files - 7 then
				portal.lista = #portal.files - 7
			end
		end
		
		if portal.foco >= #portal.files then
			portal.foco = #portal.files
		end
		
	end
	
	if controls.press("up") then
		portal.foco = portal.foco - 1
		
		if portal.foco < portal.lista + 1 and portal.foco ~= 1 then
			portal.lista = portal.lista - 1
			
			if portal.lista < 1 then
				portal.lista = 1
			end
		end
		
		if portal.foco <= 1 then
			portal.foco = 1
		end
		
	end
	
	if controls.press("left") then
		portal.foco = portal.foco - 4
		
		if portal.foco < portal.lista + 1 then
			portal.lista = portal.lista - ((portal.lista + 1) - portal.foco)
			
			if portal.lista < 1 then
				portal.lista = 1
			end
		end
		
		if portal.foco <= 1 then
			portal.foco = 1
		end
		
	end
	
	if controls.press("right") then
		portal.foco = portal.foco + 4
		
		if portal.foco > portal.lista + 6 then
			portal.lista = portal.lista + (portal.foco - (portal.lista + 6))
			
			if portal.lista > #portal.files - 7 then
				portal.lista = #portal.files - 7
			end
			
		end
		
		if portal.foco >= #portal.files then
			portal.foco = #portal.files
		end
		
	end
	
	if control.press("select") then
		if portal.seleccion == portal.foco then
			if portal.files[portal.seleccion].directory == true then
				portal.changeDir(portal.files[portal.seleccion].name)
			else
				if FILE_SELECTOR_TYPE == "files" and  portal.files[portal.seleccion].directory == true then
					system.mensaje("Alerta","","El tipo de archivo requerido es incorrecto seleccione un archivo del tipo requerido")
					return
				end
		
				portal.result = portal.files[portal.seleccion].name
				portal.open = false
			end
		else
			portal.seleccion = portal.foco
		end
	end
	
	if control.press("back") then
		if portal.ruta == "ms0:/" or portal.ruta == "ef0:/" then
			---portal.foco = 1
			portal.seleccion = 0
		else
			portal.changeDir(files.nofile(portal.ruta))
		end
	end
	
	if controls.press("start") then		
		if portal.seleccion == 0 then
			if FILE_SELECTOR_ROOT_ENABLED == true and portal.ruta == "ms0:/" or portal.ruta == "ef0:/" then
				portal.result = portal.ruta
				portal.open = false
			else
				system.mensaje("Alerta","","No se ha seleccionado ningn archivo (si desea cancelar abra el men del selector pulsando el botn triangulo)")
			end
			
			return
		end

		if FILE_SELECTOR_TYPE == "files" and  portal.files[portal.seleccion].directory == true then
			system.mensaje("Alerta","","El tipo de archivo requerido es incorrecto seleccione un archivo del tipo requerido")
			return
		end
		
		portal.result = portal.files[portal.seleccion].name
		portal.open = false
	end
	
	if portal.foco > #portal.files then
		portal.foco = #portal.files
	end
	
	if portal.foco < 1 then
		portal.foco = 1
	end
end

function portal.changeDir(ruta,archivo)
	if files.exists(ruta) == false then 
		portal.ruta = "ms0:/"
	end
	
	portal.loadDir(ruta)
end

function portal.getFileslist(ruta)

if FILE_SELECTOR_TYPE == "all" then
	tmp_files = files.list(ruta)
else
	if FILE_SELECTOR_TYPE == "directories" then
		tmp_files = files.listdirs(ruta)
	else
		tmp_files = files.list(ruta)
	end
end

if FILE_SELECTOR_FILTER ~= nil and type(FILE_SELECTOR_FILTER) == "table" then

	local lastfiles = tmp_files
	local res_files = {}
	
	for i = 1,#lastfiles do
		local ext = ""

		if lastfiles[i].directory == true then
		
		else
			ext = files.ext(lastfiles[i].name)
		end
		
		ext = tostring(ext)
		
		local isAcept = false
		
		for j = 1,#FILE_SELECTOR_FILTER do
			if ext == FILE_SELECTOR_FILTER[j] then
				isAcept = true
				break
			end
		end
		
		if isAcept == true or lastfiles[i].directory == true then
			table.insert(res_files,lastfiles[i])
		end
	end
	
	tmp_files = {}
	tmp_files = res_files
	
end

table.sort(tmp_files,portal.ordenador)

return tmp_files
end

function portal.drawactions()
	portal.actions = {}
	portal.actions.screen = screen.toimage()
	portal.actions.posy = 0 - ((#portal.opciones - 1) * 10)
	portal.actions.isclose = false
	portal.actions.foco = 1
	portal.actions.img_panel = image.create(200,(#portal.opciones * 10) + 10,color.new(220,220,220))
	
	while true do
		portal.drawpanelactions()
		if portal.actions.isclose == true and portal.actions.posy <= 0 - (#portal.opciones  * 10) then
			return false
		end
	end
	
	portal.actions.screen:blit(0,0)
	screen.flip()
end

function portal.drawpanelactions()
	if portal.actions.isclose == true then
		portal.actions.posy = portal.actions.posy - 2
	else
		portal.actions.posy = portal.actions.posy + 2
	end
	
	if portal.actions.posy > 0 then portal.actions.posy = 0 end
	if portal.actions.posy < 0 - (#portal.opciones * 10) then portal.actions.posy = 0 - (#portal.opciones * 10) end
	
	portal.actions.screen:blit(0,0)
	portal.actions.img_panel:blit(0,portal.actions.posy)
	draw.rect(-1,portal.actions.posy - 1,200,(#portal.opciones * 10) + 10,color.new(0,0,0))
	
	for i = 1,#portal.opciones do
		local x = 5
		local y = portal.actions.posy + 3 + ((i - 1) * 10)
		if portal.actions.foco == i then
			draw.fillrect(x - 2,y,193,11,color.new(130,130,130,170))
		end
		screen.print(x,y,portal.opciones[i].name,0.5,color.new(0,0,0),color.new(255,255,255))
	end
	
	screen.flip()
	controls.read()
	
	if portal.actions.posy ~= 0 then return end
	
	if control.press("back") then
		portal.actions.isclose = true
	end
	if controls.press("up") then
		portal.actions.foco = portal.actions.foco - 1
		if portal.actions.foco <= 0 then portal.actions.foco = #portal.opciones end
	end
	
	if controls.press("down") then
		portal.actions.foco = portal.actions.foco + 1
		if portal.actions.foco > #portal.opciones then portal.actions.foco = 1 end
	end
	
	if control.press("select") then
		assert(loadstring(portal.opciones[portal.actions.foco].chunk))();
		portal.actions.isclose = true
	end
end


function portal.ordenador(a,b)

if a.directory == b.directory then
	return a.name < b.name
end

return a.directory
end


portal.loadDir(FILE_SELECTOR_INIT_PATH) --- Carga la ruta seleccionada

system.closeLabel()
portal.img_screen = screen.toimage()

for i = 0,255,12 do
	portal.draw(i)
end

while portal.open do
	portal.draw(255)
end

for i = 255,-12,-12 do
	portal.draw(i)
end

if kernel ~= nil then kernel.postImage(portal.img_screen) end

tmp_result = portal.result

FILE_SELECTOR_TYPE = nil
FILE_SELECTOR_FILTER = nil
FILE_SELECTOR_NAME_FILTER = nil
FILE_SELECTOR_MULTIPLE_INTERVAL = nil
FILE_SELECTOR_INIT_PATH = nil
FILE_SELECTOR_ROOT_ENABLED = nil

if tmp_result ~= nil then
	return string.lower(tmp_result)
else
	return nil
end