---[[ SHUTDOWN PORTAL ]]---

portal.img_difuse = image.create(480,272,color.new(30,30,30,180))
portal.img_window = image.load("ms0:/FISHELL/IMG/SYSTEM/SCREEN/shutdown.png")
portal.img_focus = image.load("ms0:/FISHELL/SRC/PORTAL/SHUTDOWN/src/focus.png") 
portal.transdifuse = 0
portal.foco = 1
portal.focoy = 49 - 4
portal.isrun = true

portal.text = {
	"Salir de FISHELL",
	"Suspender PSP",
	"Apagar PSP",
	"Reiniciar FISHELL",
	"Cerrar sesin",
	"Cancelar"
}

portal.text[1] = { name = getText("salir de fishell") , chunk = "system.exit()" }
portal.text[2] = { name = getText("suspender psp") , chunk = "power.suspend()" }
portal.text[3] = { name = getText("apagar psp") , chunk = "system.shutdown()" }
portal.text[4] = { name = getText("reiniciar fishell") , chunk = "system.reloadSystem()" }
portal.text[5] = { name = getText("cerrar sesion") , chunk = "system.closeSesion()" }
portal.text[6] = { name = getText("cancelar") , chunk = "" }

function portal.draw(trans)
	if trans == nil then trans = 255 end
	
	portal.img_screen:blit(0,0)
	portal.img_difuse:blend(0,0,portal.transdifuse)
	portal.img_window:blend(0,0,trans)
	
	for i = 1,6 do
		local x = 163
		local y = 49 + ((i - 1) * 25)
		
		screen.print(x + 43,y + 2,portal.text[i].name,0.6,color.new(0,0,0,trans),0x0)

		if portal.foco == i then
			local focy = y - 4
			
			if portal.focoy < focy then portal.focoy = portal.focoy + 2 end
			if portal.focoy > focy then portal.focoy = portal.focoy - 2 end
		end
	end
	
	portal.img_focus:blend(158,portal.focoy,trans)
	
	screen.flip()
	
	if trans == 255 and portal.isrun == true then
		portal.transdifuse = portal.transdifuse + 1.75
		if portal.transdifuse > 255 then portal.transdifuse = 255 end
		portal.leerControles()
	else
		portal.transdifuse = portal.transdifuse - 12
		if portal.transdifuse < 0 then portal.transdifuse = 0 end
	end
end
 
function portal.leerControles()
	controls.read()
	
	if controls.press("down") then
		portal.foco = portal.foco + 1
		if portal.foco > 6 then portal.foco = 6 end
		controls.read()
	end
	
	if controls.press("up") then
		portal.foco = portal.foco - 1
		if portal.foco < 1 then portal.foco = 1 end
		controls.read()
	end
	
	if controls.press(control.config["back"]) then
		portal.isrun = false
		return
	end
	
	if controls.press(control.config["select"]) then
		portal.isrun = false
		assert(loadstring(portal.text[portal.foco].chunk))();
		return
	end
	
end

system.closeLabel()
portal.img_screen = screen.toimage()

for i = 0,255,13 do
	portal.draw(i)
end

while portal.isrun do
	portal.draw()
end

for i = 255,-10,-13 do
	portal.draw(i)
end

if kernel ~= nil then kernel.postImage(portal.img_screen) end

return nil