------------------------------------------------------------------------
--- Script principal del FISHELL 1.0 @ zerozelta | www.zerozelta.tk ----
------------------------------------------------------------------------

os.cpu(333) 			-- acelera la cpu del psp
controls.homepopup(0) 	-- desactiva el home de la psp

---- Funcion del menú recovery ----
controls.read()

if controls.r() == true or controls.l() == true then 
	if files.exists("RECOVERY/recovery.lua") then
		dofile("RECOVERY/recovery.lua") 
	else
		dofile("RECOVERY/recovery.lue")
	end
end
------------------------------------


---_Cargando libreria ULD_---
dofile("uld_lib/ULD.lua")

---_Cargando modulo system.lua_---
if files.exists("ms0:/FISHELL/SRC/DOC/system.lua") then
	dofile("ms0:/FISHELL/SRC/DOC/system.lua")
else
	dofile("ms0:/FISHELL/SRC/DOC/system.lue")
end


if system.isCorruptedSystem() then
	system.mensajeCritico("error-code: 001")
end


if system.isInstall() == false then
	system.dofile("ms0:/FISHELL/SRC/install.lua")  --- Inicia el instalador de fishell
else
	system.dofile("ms0:/FISHELL/INSTALL/install.ini")
end

-----------------------------------------------
-- Funciones para el envio de archivos ms-ms --
-----------------------------------------------

if files.exists("ms0:/FISHELL/ms-ms.send") then  --- Envio de archivos via ms - ms
	local mss_text = uld.filesRead("ms0:/FISHELL/ms-ms.send")[1]
	
	if mss_text == "[DISABLED]" then
		files.remove("ms0:/FISHELL/ms-ms.send",true,true)
		return
	end
	
	system.dofile("ms0:/FISHELL/SRC/DOC/mss.lua")
	uld.loadlib("consola")
	MSS.InitSend(mss_text,true)
	files.remove("ms0:/FISHELL/ms-ms.send",true,true)
	controls.homepopup(0)
end

if system.isSesion() then
	system.dofile("ms0:/FISHELL/SRC/loader.lua")  	-- Carga la sesion del usuario
else
	system.initSystemBoot()							-- Comienza la seccion de Inicio De Sesion
end