--- Libreria de Consola @autor: zerozelta ---

uld.console = {}

function uld.console.println(lines,texto,col,wait)
	local wait = wait
	local col = col
	
	if wait == nil then wait = 20 end
	
	if col == nil then
		col = color.new(255,255,255)
	end
	
	if texto == nil then 
		texto = "" 
	end
	
	table.insert(lines,{ txt = texto , col = col })
	
	local init = 0
	
	if #lines - 22 > 0 then
		init = #lines - 22
	end
	
	for i = 1,22 do
		local j = i + init
		if lines[j] == nil then break end
		
		local x = 5
		local y = 5 + ((i - 1) * 11)
		screen.print(x,y,lines[j].txt,0.5,lines[j].col,0x0)
		i = i + 1
	end
	
	screen.flip()
	screen.waitvblankstart(wait)
end

function uld.console.option(lines,texto)
	uld.console.println(lines,nil,nil,0)
	uld.console.println(lines,"-----------------------------------------------------------------",nil,0)
	uld.console.println(lines,texto,color.new(240,240,0),0)
	uld.console.println(lines,"X = Acept   |   O = Cancel",nil,0)
	uld.console.println(lines,"-----------------------------------------------------------------",nil,0)
	
	local result;
	
	while true do
		controls.read()
		
		if controls.press("cross") then
			result = true
			break
		end
		
		if controls.press("circle") then
			result = false
			break
		end
	end
	
	return result
end

function uld.console.refresh(lines)

	local init = 0
	
	if #lines - 22 > 0 then
		init = #lines - 22
	end
	
	for i = 1,22 do
		local j = i + init
		if lines[j] == nil then break end
		
		local x = 5
		local y = 5 + ((i - 1) * 11)
		screen.print(x,y,lines[j].txt,0.5,lines[j].col,0x0)
		i = i + 1
	end
	
	screen.flip()
end

function uld.console.editLine(lines,index,texto)
	if index == nil then 
		index = #lines
	end
	
	lines[index].txt = texto
	uld.console.refresh(lines)
end

function uld.console.waitKey(llave)
	if llave == nil then llave = "cross" end
	
	while true do
		controls.read()
		
		if controls.press(llave) then
			break
		end
	end
end