--- Documentacion del modulo fishbarr para la barra de herramientas de fishell ---
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com


fishbar = {}

if cfg.color_main_icon == nil then
	fishbar.icon1 = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/butt1.png")
	fishbar.icon2 = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/butt2.png")
else
	fishbar.icon1 = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/butt1_tint.png")
	fishbar.icon2 = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/butt2_tint.png")
end

fishbar.background = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/background.png")
fishbar.img_date = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/date.png")
fishbar.img_coment = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/coment.png")
fishbar.img_toDesck = image.load("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM/fishbar/todescktop.png")

fishbar.icon_trans = 0
fishbar.h = 50 + 80
fishbar.objh = 50 + 80
fishbar.x = 0
fishbar.panel = nil
fishbar.panel_activado = false

fishbar.apps = {}
fishbar.menuItems = {}
fishbar.apps_focus = 0

fishbar.RTime = timer.new()
fishbar.RTime:start()
fishbar.shora = ""
fishbar.sfecha = ""

fishbar.batery_plugin = { img = image.load("ms0:/FISHELL/IMG/SYSTEM/battery.png") , trans = 0 , tmp = 0 , crono = 0 , crono2 = 30}
fishbar.usb_plugin = { img = image.load("ms0:/FISHELL/IMG/SYSTEM/usb_drive.png") , color1 = color.new(0,0,0) , color2 = color.new(87,197,240) , color3 = color.new(97,232,56) , tmp = 0 , crono = 0 , tmp2 = nil , crono2 = 30 , trans = 0}

fishbar.brillo_barra = brightness.new("blanco")

function fishbar.drawDate()
	fishbar.date_x = fishbar.h - 80
	fishbar.date_y = 272 - 41
	fishbar.img_date:blit(fishbar.date_x,fishbar.date_y)
	uld.printCenter(fishbar.date_x,fishbar.date_y + 7,fishbar.shora,0.57,color.new(30,30,30),color.new(255,255,255,200),80)
	uld.printCenter(fishbar.date_x,fishbar.date_y + 22,fishbar.sfecha,0.57,color.new(30,30,30),color.new(255,255,255,200),80)

	if fishbar.RTime:time() >= 2000 then
		fishbar.shora = os.date("%I:%M %p")
		fishbar.sfecha = os.date("%d/%m/%y")
		fishbar.RTime:reset()
	end
end

function fishbar.drawPlugins()
fishbar.background:blit(fishbar.h + 4,272 - 40 - 2,fishbar.h + 2,0,27,40) 
draw.rect(fishbar.h + 4,272 - 40 - 2,27,40,color.new(0,0,0,130))

----_plugin battery_---
fishbar.batery_plugin.crono = fishbar.batery_plugin.crono - 1
if fishbar.batery_plugin.crono <= 0 then fishbar.batery_plugin.crono = 30; fishbar.batery_plugin.tmp = batt.percent() end

if batt.charging() and (fishbar.h + 2 + 2 + 4) > 30 then 
	if fishbar.batery_plugin.tmp > 0 then
	draw.fillrect(fishbar.h + 2 + 2 + 5, 274 - 38,math.ceil((14 / 100) * fishbar.batery_plugin.tmp),6,color.new(21,60,230))
	end
else
	if fishbar.batery_plugin.tmp > 0 then
	draw.fillrect(fishbar.h + 2 + 2 + 5, 274 - 38,math.ceil((14 / 100) * fishbar.batery_plugin.tmp),6,color.new(0,0,0))
	end
end

if batt.exists() == false then tmp_cargando = nil end

fishbar.batery_plugin.img:blit(fishbar.h + 2 + 4, 272 - 40) 
if uld.isOver(fishbar.h + 4,272 - 42,25,20,puntero.x,puntero.y) then
	puntero.overOn("popup")
	fishbar.plugins.battery(12,fishbar.batery_plugin.tmp) 
	if control.press("menu") then
		descktop.focusinpopup = 0
		eleme = {}
		eleme[1] = { texto = getText("mas informacion"), accion = "" , est = false }

		popup.setElements(eleme)
		popup.activate()
	end
else 
	fishbar.plugins.battery(-12,fishbar.batery_plugin.tmp)
end
 
-----------------------------

----_plugin usb drive_-------
fishbar.usb_plugin.crono = fishbar.usb_plugin.crono - 1
if fishbar.usb_plugin.crono <= 0 then 
	fishbar.usb_plugin.crono = 60
	fishbar.usb_plugin.tmp = usb.status()
	fishbar.usb_plugin.tmp2 = usb.state() 
	end

if fishbar.usb_plugin.tmp == true then
	if fishbar.usb_plugin.tmp2.established == true then
		draw.fillrect(fishbar.h + 2 + 6,274 - 22,19,11,fishbar.usb_plugin.color3)
	else
		draw.fillrect(fishbar.h + 2 + 6,274 - 22,19,11,fishbar.usb_plugin.color2)
	end
else
	draw.fillrect(fishbar.h + 2 + 5,274 - 22,19,11,fishbar.usb_plugin.color1)
end

fishbar.usb_plugin.img:blit(fishbar.h + 2 + 4, 272 - 22) 

if uld.isOver(fishbar.h + 4,272 - 42 + 21,25,20,puntero.x,puntero.y) then
	puntero.overOn("popup")
	fishbar.plugins.usbDrive(12,fishbar.usb_plugin.tmp,fishbar.usb_plugin.tmp2) 
	
	if control.press("select") then
		if fishbar.usb_plugin.tmp == true then
			--- USB activado
			usb.off()
			fishbar.usb_plugin.tmp = false
		else
			--- USB desactivado
			usb.on()
			fishbar.usb_plugin.tmp = true
		end
	end
	
	if control.press("menu") then
		descktop.focusinpopup = 0
		eleme = {}
		eleme[1] = { texto = getText("activar") , accion = "usb.on()" , est = true }
		eleme[2] = { texto = getText("desactivar") , accion = "usb.off()" , est = true }
		eleme[3] = { texto = getText("conectar gamepad") , accion = "optionpanel.init('"..getText("desea iniciar gamepad").." "..getText("(se cerraran ventanas)").."','system.efectDifuse(); os.runeboot(\"ms0:/FISHELL/PORTAL/FUSAGAMEPAD/EBOOT.PBP\")')" , est = true }

		popup.setElements(eleme)
		popup.activate()
	end
else
	fishbar.plugins.usbDrive(-12,fishbar.usb_plugin.tmp,fishbar.usb_plugin.tmp2) end

end

function fishbar.draw()
if fishbar.objh > fishbar.h then fishbar.h = fishbar.h + 1 end
if fishbar.objh < fishbar.h then fishbar.h = fishbar.h - 1 end

if uld.isOver(fishbar.h + 28 + 5,272 - 42,15,40,puntero.x,puntero.y) then
	fishbar.img_toDesck:blend(fishbar.h + 28 + 5,272 - 42,255)
	puntero.overOn("link");
	if control.press("select") and app.desenfocando == false then
	
		if descktop.focoin ~= "escritorio" then
			app.desenfocar()
			app.minimeAll()
		else
			if app.isMinimeAll() == true then
				app.showAllWindows()
			else
				app.minimeAll()
			end
		end 
 
	end
else
	fishbar.img_toDesck:blend(fishbar.h + 28 + 5,272 - 42,130)
end

if cfg.draw_full_fishbar == true then
	fishbar.h = 480 - 52
	fishbar.objh = 480 - 52
end

fishbar.background:blit(2,272 - 42,0,0,fishbar.h,40)

if fsl ~= nil then
	fsl.drawFishWave()  -- Dubuja ola interna de la fishbare
end

if uld.isOver(42,272 - 42,fishbar.h - 40,40,puntero.x,puntero.y) then
	brightness.draw(fishbar.brillo_barra,puntero.x - 50,272 - 10 - 50,6)
else
	brightness.draw(fishbar.brillo_barra,brightness.getX(fishbar.brillo_barra),272 - 10 - 50,-6)
end

draw.rect(2,272 - 40 - 2,fishbar.h,40,color.new(0,0,0,130)) -- Contorno de la fishbar

if uld.isOver(0,272 - 39,40,40,puntero.x,puntero.y) then
	fishbar.icon_trans = fishbar.icon_trans + 7 
	puntero.overOn("link")
	if fishbar.icon_trans >= 255 then fishbar.icon_trans = 255 end
	if control.press("select") then 
		-------------------------------------------------------> Accion al presionar el boton del menu principal
		main_menu.activate()
	end
else
	fishbar.icon_trans = fishbar.icon_trans - 7
	if fishbar.icon_trans <= 0 then fishbar.icon_trans = 0 end
end

if fishbar.panel_activado == true then 
	fishbar.icon_trans = fishbar.icon_trans + 10
	if fishbar.icon_trans > 255 then fishbar.icon_trans = 255 end
end

if cfg.color_main_icon == nil then
	fishbar.icon1:blend(0,272 - 65,255)
	fishbar.icon2:blend(0,272 - 65,fishbar.icon_trans)
else
	image.fxtint(0,272 - 65,fishbar.icon1,color.new(cfg.color_main_icon.R,cfg.color_main_icon.G,cfg.color_main_icon.B,255))
	image.fxtint(0,272 - 65,fishbar.icon2,color.new(cfg.color_main_icon.R,cfg.color_main_icon.G,cfg.color_main_icon.B,fishbar.icon_trans))
end

fishbar.drawDate() 			-- Dubujando fecha y hora
fishbar.drawFBH()  			-- Dubujando programas abiertos
main_menu.draw()			-- Dubujando menu principal de la fishbar (En caso de que este activado)
fishbar.drawPlugins() 		-- Dibujando plugins
end

function fishbar.drawFBH()
if table.maxn(fishbar.apps) == 0 then return nil end

for i = 1,table.maxn(fishbar.apps) do
	local fbtmp_x = 48 + (35 * (i - 1)) + ((i - 1) * 3) - (i - 1)
	local fbtmp_y = 272 - 40
	
	if fishbar.apps[i].fbh_visible == false and fishbar.objh == fishbar.h and fishbar.apps[i].close == false then fishbar.apps[i].fbh_visible = true end
	
	if fishbar.apps[i].fbh_visible == true then 
		fishbar.apps[i].fbh_trans = fishbar.apps[i].fbh_trans + 8
		if fishbar.apps[i].fbh_trans > 255 then fishbar.apps[i].fbh_trans = 255 end
	else
		fishbar.apps[i].fbh_trans = fishbar.apps[i].fbh_trans - 8
		if fishbar.apps[i].fbh_trans < 0 then fishbar.apps[i].fbh_trans = 0 end
	end
	
	
	if uld.isOver(fbtmp_x,fbtmp_y,35,36,puntero.x,puntero.y) and fishbar.apps[i].fbh_trans == 255 then 
		puntero.overOn("popup_link")
		
		if control.press("select") then
			app.changeFocus(i)  --- Enfoca aplicacion correspondiente
		end
		
		if control.press("menu") then 
			descktop.focusinpopup = 0
			eleme = {}
			eleme[1] = { texto = getText("cerrar") , accion = "app.close("..i..")" , est = true }
			eleme[2] = { texto = getText("minimizar") , accion = "app.minimize("..i..")" , est = true }
			eleme[3] = { texto = getText("crear accs dir") , accion = "descktop.makeAccsDir(\""..fishbar.apps[i].cfg.title_for_accs.."\",\"install/icon.png\",\"APP\",\""..fishbar.apps[i].id.."\")" , est = true }
			
			popup.setElements(eleme)
			popup.activate()
		end
	end
	
	if fishbar.apps[i].fbh_lastp == nil then
		fishbar.apps[i].fbh_lastp = fbtmp_x
	else
		if fishbar.apps[i].fbh_lastp > fbtmp_x then
			fishbar.apps[i].fbh_lastp = fishbar.apps[i].fbh_lastp - 2
			if fishbar.apps[i].fbh_lastp <= fbtmp_x then fishbar.apps[i].fbh_lastp = fbtmp_x end
			fbtmp_x = fishbar.apps[i].fbh_lastp
		else
			fishbar.apps[i].fbh_lastp = fbtmp_x
		end
	end
	
	fishbar.img_fbh:blend(fbtmp_x,fbtmp_y,fishbar.apps[i].fbh_trans)
	
	if fishbar.apps_focus == i and fishbar.apps[i].trans == 255 then
		fishbar.apps[i].efect.focus = fishbar.apps[i].efect.focus + 10
	else
		fishbar.img_fbh:blend(fbtmp_x,fbtmp_y,fishbar.apps[i].fbh_trans)
		fishbar.apps[i].efect.focus = fishbar.apps[i].efect.focus - 10
	end
	
	if fishbar.apps[i].efect.focus > 255 then fishbar.apps[i].efect.focus = 255 end
	if fishbar.apps[i].efect.focus < 0   then fishbar.apps[i].efect.focus = 0   end
	
	if fishbar.apps[i].efect.focus ~= 0 then 
		fishbar.img_fbh2:blend(fbtmp_x,fbtmp_y,fishbar.apps[i].efect.focus) 
	end
	
	fishbar.apps[i].icon:blend(fbtmp_x,fbtmp_y,fishbar.apps[i].fbh_trans)
	
	if fishbar.apps[i].minimize == true then
		fishbar.apps[i].efect.minim = fishbar.apps[i].efect.minim + 10
	else
		fishbar.apps[i].efect.minim = fishbar.apps[i].efect.minim - 10
	end
	
	if fishbar.apps[i].efect.minim > 255 then fishbar.apps[i].efect.minim  = 255 end
	if fishbar.apps[i].efect.minim < 0   then fishbar.apps[i].efect.minim  = 0   end
	
	if fishbar.apps[i].efect.minim ~= 0 then fishbar.img_fbh_minimize:blend(fbtmp_x,fbtmp_y,fishbar.apps[i].efect.minim) end
end

end


--------------------------------------------------------------------------------
-------------------_PLUGINS PARA LA BARRA DE HERRAMIENTAS_----------------------
--------------------------------------------------------------------------------

fishbar.plugins = {}

function fishbar.plugins.battery(modo,porcent)
if modo > 0 then
	fishbar.batery_plugin.crono2 = fishbar.batery_plugin.crono2 - 1
	if fishbar.batery_plugin.crono2 < 0 then fishbar.batery_plugin.crono2 = 0 end
	if fishbar.batery_plugin.crono2 ~= 0 then return end
else
	fishbar.batery_plugin.crono2 = fishbar.batery_plugin.crono2 + 1
	if fishbar.batery_plugin.crono2 > 30 then fishbar.batery_plugin.crono2 = 30 end
end

fishbar.batery_plugin.trans = fishbar.batery_plugin.trans + modo

if fishbar.batery_plugin.trans <= 0 then 
	fishbar.batery_plugin.trans = 0
	return
end

if fishbar.batery_plugin.trans > 255 then fishbar.batery_plugin.trans = 255 end

if fishbar.h + 115 > 480 then
centrador = (fishbar.h + 115 - 478)
fishbar.img_coment:blend(fishbar.h - centrador, 272 - 46 - 42 , fishbar.batery_plugin.trans)

screen.print(fishbar.h + 7 - centrador,272 - 42 - 40,porcent.."%",0.5,color.new(25,25,25,fishbar.batery_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans))

if batt.charging() == true then
screen.print(fishbar.h + 110 - centrador,272 - 42 - 40,"+++",0.5,color.new(25,25,25,fishbar.batery_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans),"right",70)
else
screen.print(fishbar.h + 110 - centrador,272 - 42 - 40,batt.time().." mts.",0.5,color.new(25,25,25,fishbar.batery_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans),"right",70)
end

draw.fillrect(fishbar.h + 5 - centrador, 272 - 46 - 18,(105 / 100) * porcent,8,color.new(40,240,50,fishbar.batery_plugin.trans - 7)) 
draw.fillrect(fishbar.h + 5 - centrador, 272 - 46 - 18,(105 / 100) * porcent,4,color.new(255,255,255,fishbar.batery_plugin.trans - 120))
draw.rect(fishbar.h + 5 - centrador, 272 - 46 - 18,105,8,color.new(0,0,0,fishbar.batery_plugin.trans - 20)) 
else
fishbar.img_coment:blend(fishbar.h, 272 - 46 - 42 , fishbar.batery_plugin.trans)

screen.print(fishbar.h + 7,272 - 42 - 40,porcent.."%",0.5,color.new(25,25,25,fishbar.batery_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans))

if batt.charging() == true then
screen.print(fishbar.h + 110,272 - 42 - 40,"+++",0.5,color.new(25,25,25,fishbar.batery_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans),"right",70)
else
screen.print(fishbar.h + 110,272 - 42 - 40,batt.time().." mts.",0.5,color.new(25,25,25,fishbar.batery_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans),"right",70)
end

draw.fillrect(fishbar.h + 5, 272 - 46 - 18,(105 / 100) * porcent,8,color.new(40,240,50,fishbar.batery_plugin.trans - 7)) 
draw.fillrect(fishbar.h + 5, 272 - 46 - 18,(105 / 100) * porcent,4,color.new(255,2550,255,fishbar.batery_plugin.trans - 120)) 
draw.rect(fishbar.h + 5, 272 - 46 - 18,105,8,color.new(0,0,0,fishbar.batery_plugin.trans - 20)) 
end

end

function fishbar.plugins.usbDrive(modo,activado,tabla)

if modo > 0 then
	fishbar.usb_plugin.crono2 = fishbar.usb_plugin.crono2 - 1
	if fishbar.usb_plugin.crono2 < 0 then fishbar.usb_plugin.crono2 = 0 end
	if fishbar.usb_plugin.crono2 ~= 0 then return end
else
	fishbar.usb_plugin.crono2 = fishbar.usb_plugin.crono2 + 1
	if fishbar.usb_plugin.crono2 > 30 then fishbar.usb_plugin.crono2 = 30 end
end

fishbar.usb_plugin.trans = fishbar.usb_plugin.trans + modo

if fishbar.usb_plugin.trans <= 0 then
	fishbar.usb_plugin.trans = 0
	return 
end

if fishbar.usb_plugin.trans > 255 then fishbar.usb_plugin.trans = 255 end

if fishbar.h + 115 > 480 then
centrador = (fishbar.h + 115 - 478)
	
	fishbar.img_coment:blend(fishbar.h - centrador, 272 - 46 - 42,fishbar.usb_plugin.trans)
	
	if activado == true then 
		screen.print(fishbar.h + 2 - centrador,272 - 44 - 41,getText("drive")..": "..getText("activado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	else
		screen.print(fishbar.h + 2 - centrador,272 - 44 - 41,getText("drive")..": "..getText("desactivado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	end
	
	if tabla.established == true then
		screen.print(fishbar.h + 2 - centrador,272 - 42 - 40 + 8,getText("conexion")..": "..getText("si"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans))
	else
		screen.print(fishbar.h + 2 - centrador,272 - 42 - 40 + 8,getText("conexion")..": "..getText("no"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	end
	
	if tabla.connected == true then
		screen.print(fishbar.h + 2 - centrador,272 - 42 - 40 + 18,getText("cable")..": "..getText("conectado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	else
		screen.print(fishbar.h + 2 - centrador,272 - 42 - 40 + 18,getText("cable")..": "..getText("desconectado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	end
	
else
	fishbar.img_coment:blend(fishbar.h, 272 - 46 - 42 ,fishbar.usb_plugin.trans)
	
	if activado == true then 
		screen.print(fishbar.h + 2,272 - 44 - 41,getText("drive")..": "..getText("activado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	else
		screen.print(fishbar.h + 2,272 - 44 - 41,getText("drive")..": "..getText("desactivado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	end
	
	if tabla.established == true then
		screen.print(fishbar.h + 2,272 - 42 - 40 + 8,getText("conexion")..": "..getText("si"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.batery_plugin.trans))
	else
		screen.print(fishbar.h + 2,272 - 42 - 40 + 8,getText("conexion")..": "..getText("no"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	end
	
	if tabla.connected == true then
		screen.print(fishbar.h + 2,272 - 42 - 40 + 18,getText("cable")..": "..getText("conectado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	else
		screen.print(fishbar.h + 2,272 - 42 - 40 + 18,getText("cable")..": "..getText("desconectado"),0.5,color.new(25,25,25,fishbar.usb_plugin.trans),color.new(230,230,230,fishbar.usb_plugin.trans))
	end
end

end