----- Modulo home
----- documentacion del menu home especial para FISHELL
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

home = {}
-- home.sound = sound.load("ms0:/FISHELL/MEDIA/home.mp3")
home.bars = { img = image.load("ms0:/FISHELL/IMG/SYSTEM/HOME/barra.png") , int = 0 , y1 = 0 , y2 = 0 , te = false}
home.font = font.load("ms0:/FISHELL/FONTS/fish_2.pgf")
home.foco = image.create(300,12,color.new(255,255,255,125))
home.brilloA = brightness.new("blanco")
home.foco_pos = 1
home.salir = false

home.usb_state = { activado = false , conectado = false , establesido = false , y = 272 ,  brillox = 0 , trans = 0 , img = image.load("ms0:/FISHELL/IMG/SYSTEM/HOME/usb_drive.png")}
home.menu = {}

function home.drawInfo(trans)
	if trans == nil then trans = 255 end
	screen.print(380,7,os.date("%I:%M:%S %p"),0.7,color.new(255,255,255,trans),color.new(100,100,100,trans))
end

function home.init()
	if brightness == nil then system.dofile("ms0:/FISHELL/SRC/DOC/brightness.lua") end
	home.bars.int = ( table.maxn(home.menu) * 15) / 2 + 10
	home.bars.y1 = 0
	home.bars.y2 = 0
	home.bars.te = false
	home.salir = false
	home.foco_pos = 1
	home.usb_state.y = 272
	home.usb_state.brillox = 0
	home.usb_state.trans = 0
end

function home.free()
home.brilloA = nil
--home.sound:free()

home.bars.int = nil
home.bars.y2 = nil
home.bars.te = nil
home.salir = nil
home.foco_pos = nil
home.usb_state.y = nil
home.usb_state.brillox = nil
home.usb_state.trans = nil

collectgarbage("collect")
end

function home.leerControles()
controls.read()

if controls.press(control.config["select"]) then
codigo_a_ejecutar = home.menu[home.foco_pos].chunk
assert(loadstring(codigo_a_ejecutar))();
controls.read()
return
end

if controls.press("up") then 
home.foco_pos = home.foco_pos - 1 
if home.foco_pos <= 0 then home.foco_pos = table.maxn(home.menu) end
end

if controls.press("down") then 
home.foco_pos = home.foco_pos + 1
if home.foco_pos > table.maxn(home.menu) then home.foco_pos = 1 end
end

if controls.press("select") then
home.salir = true
end

end

function home.printListB()
if table.maxn(home.menu) == 0 then return end
base = 125 - home.bars.y1 + 10

---- aqui pintamos el foco
home.foco:blend(90,base + (15 * home.foco_pos) - 2,255)
----------

for i = 1,table.maxn(home.menu) do
   if home.menu[i] ~= nil then
   screen.print(home.font,90,base + (15 * i),home.menu[i].texto,0.6,color.new(0,0,0,255),color.new(255,255,255))
   end
end
end

function home.printList(trans)
if trans == ni then trans = 255 end
if home.font == nil then font.load("ms0:/FISHELL/FONTS/gothic.pgf") end

if home.bars.y1 < home.bars.int then home.bars.y1 = home.bars.y1 + 2 end
if home.bars.y2 < home.bars.int then home.bars.y2 = home.bars.y2 + 2 end

if home.bars.te == true then
home.printListB()
else
if home.bars.y1 >= home.bars.int then 
home.bars.te = true
end
end

home.bars.img:blend(83,125 - home.bars.y1,trans)
home.bars.img:blend(83,140 + home.bars.y2,trans)
end

function home.usb_drive()
st = usb.state()
if st.connected then home.usb_blit_drive(-3,getText("conexion usb")) return else home.usb_blit_drive(3,getText("conexion usb")) end
end

function home.usb_blit_drive(metodo,paleta)

home.usb_state.trans = home.usb_state.trans - (metodo * 2)
home.usb_state.y = home.usb_state.y + metodo

if home.usb_state.trans < 0 then home.usb_state.trans = 0 return end
if home.usb_state.trans > 255 then home.usb_state.trans = 255 end

if home.usb_state.y > 272 then home.usb_state.y = 272 return end
if home.usb_state.y < 212 then home.usb_state.y = 212 end

if home.usb_state.img == nil then home.usb_state.img = image.load("ms0:/FISHELL/IMG/SYSTEM/HOME/usb_drive.png") end
if home.brilloA == nil then home.brilloA = brightness.new("blanco") end

home.usb_state.brillox = home.usb_state.brillox + 2
if home.usb_state.brillox >= 575 then home.usb_state.brillox = -50; home.brilloA.trans = 0 end

brightness.draw(home.brilloA,home.usb_state.brillox,272 - 50 + (home.usb_state.y - 212),6)
home.usb_state.img:blend(0,home.usb_state.y,home.usb_state.trans) 
screen.print(home.font,50,home.usb_state.y + 43,paleta,0.7,color.new(230,230,230,home.usb_state.trans),color.new(255,255,255,home.usb_state.trans))
end

function home.run()
home.screen = screen.toimage()
home.fondo = image.load("ms0:/FISHELL/IMG/SYSTEM/HOME/home.png")
home.init()

--[[
if home.sound == nil then home.sound = sound.load("ms0:/FISHELL/MEDIA/home.mp3") end
if home.bars.img ==  nil then home.bars = image.load("ms0:/FISHELL/IMG/SYSTEM/HOME/barra.png") end

home.sound:play(1);
]]--

for i = 0,255,18 do
home.screen:blend(0,0,255)
home.fondo:blend(0,0,i)
home.printList(i)
home.drawInfo(i)
screen.flip()
end

while true do
if home.salir == true then break end
home.leerControles()
home.fondo:blend(0,0,255)
home.printList()
home.drawInfo()
home.usb_drive()
screen.flip()

sonido.runDrive() -- Avilita el drive de sonido
power.tick(power.tick_all) -- evita que la psp apage la pantalla y se suspenda
end

for i = 255,0,-15 do
home.screen:blend(0,0,255)
home.fondo:blend(0,0,i)
home.drawInfo(i)
screen.flip()
end

if kernel ~= nil then kernel.postImage(home.screen) end
home.screen:free()
home.fondo:free()
collectgarbage("collect")
end

dofile("ms0:/FISHELL/CFG/home.ini")
