--- Modulo popup 

--[[  CONFORMACION DE LOS ELEMENTOS DE LOS POPUP MENUS
	element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
]]--

-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

popup = {}
popup.x = 0
popup.y = 0
popup.w = 150 
popup.h = 0
popup.elements = {}
popup.trans = 0
popup.llave = 9096
popup.activado = false
popup.desactivar = false
popup.chunkToClose = nil
popup.tmpef1 = false

function popup.draw()
if popup.activado == false then return end

if popup.desactivar == false then
	popup.trans = popup.trans + 10
else
	popup.trans = popup.trans - 20
end

if popup.trans < 0 then popup.trans = 0 end
if popup.trans > 255 then popup.trans = 255 end


if popup.trans == 0 and popup.desactivar == true then
	if popup.tmpef1 == false then
		popup.tmpef1 = true
	else
		popup.desactivate();
		return 
	end
end

local nume = table.maxn(popup.elements)

if nume == 0 then return end

puntero.interactive_type = 0

if popup.w + popup.x > 480 then
popup.x = popup.x - ((popup.w + popup.x) - 480) - 6
end

if popup.y + (18 * (nume) + (nume * 2)) > 272 then
	popup.y = popup.y - (popup.y + (18 * (nume) + (nume * 2)) - 272) - 6
end

if popup.trans == 255 then draw.fillrect(popup.x + 2,popup.y + 2,popup.w + 2,popup.h + 2 , color.new(0,0,0,140)) end
draw.gradrect(popup.x,popup.y,popup.w + 2,popup.h + 2,color.new(255,255,255,popup.trans),color.new(255,255,255,popup.trans),color.new(180,180,180,popup.trans),color.new(180,180,180,popup.trans))
draw.rect(popup.x,popup.y,popup.w + 2,popup.h + 2,color.new(20,20,20,popup.trans))

if popup.h < 18 * (nume) + (nume * 2) then
	popup.h = popup.h + 4
	return 
end

for i = 1,nume do
	cx = popup.x + 2
	cy = popup.y + 2 + (18 * (i - 1) + ((i - 1) * 2))
	
	if popup.elements[i].est == true and puntero.isOver(cx,cy,popup.w - 4,18) then
		draw.fillrect(cx,cy,popup.w - 2,18,color.new(110,110,110,popup.trans))
		puntero.overOn("link")
		if controls.press(control.config["select"]) then
			if popup.elements[i].accionToClose ~= nil and popup.elements[i].accionToClose == true then
				popup.chunkToClose = popup.elements[i].accion
				popup.desactivar = true
			else
				assert(loadstring(popup.elements[i].accion))();
				popup.desactivar = true
			end
		end
	end
	
	font_color = color.new(20,20,20,popup.trans)
	
	if popup.elements[i].est == false then 
		draw.fillrect(cx,cy,popup.w - 2,18,color.new(170,170,170,popup.trans))
		font_color = color.new(100,100,100,popup.trans)		
	end
	
	--draw.rect(cx,cy,popup.w - 2,18,color.new(20,20,20,popup.trans))
	screen.print(cx + 3,cy + 3,popup.elements[i].texto,0.5,font_color,color.new(255,255,255,popup.trans - 20),"scroll_left",popup.w)
end

if controls.press(control.config["menu"]) then
	popup.desactivar = true
	controls.read()
end

if controls.press(control.config["back"]) then
	popup.desactivar = true
end

if controls.press(control.config["home"]) then
	---popup.desactivar = true
	home.run()
end

if controls.square() or controls.press("r") or controls.press("l") then
	popup.desactivar = true
end

if puntero.isOver(popup.x,popup.y,popup.w,popup.h) == false then
	if controls.press(control.config["select"]) then
	popup.desactivar = true
	controls.read()
	end
end

end

function popup.activate()
popup.trans = 0
popup.h = 0
popup.x = puntero.x
popup.y = puntero.y
popup.w = popup.getWidth()
popup.activado = true
popup.desactivar = false
kernel.isPopup = true
control.lock(popup.llave)
end

function popup.desactivate()

popup.trans = 0
popup.activado = false
popup.desactivar = false
kernel.isPopup = false
popup.tmpef1 = false
control.unlock()

if popup.chunkToClose ~= nil then
	assert(loadstring(popup.chunkToClose))();
	popup.chunkToClose = nil
end

popup.w = 10
popup.elements = nil
popup.elements = {}

end

function popup.getWidth()
	local w = 10
	
	for i = 1,#popup.elements do
		w = math.max(w,screen.textwidth(popup.elements[i].texto,0.5))
	end
	
	w = math.min(350,w)
	
	return w + 10
end

function popup.setElements(elements)
	popup.elements = nil
	popup.elements = elements
end