--- Modulo Option Panel 
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com
-- 1 = SI; 2 = NO;

optionpanel = {}
optionpanel.x = 0
optionpanel.y = 0
optionpanel.w = 0
optionpanel.llave = 0927123
optionpanel.chNO = nil
optionpanel.chSI = nil

optionpanel.tmpef1 = false

optionpanel.focoIn = 0

function optionpanel.load()
optionpanel.img_panel = image.load(LOG_THEME_PATH.."CUSTOM/system/option_panel/window.png")
optionpanel.img_btt1 = image.load(LOG_THEME_PATH.."CUSTOM/system/option_panel/butt1.png")
optionpanel.img_btt2 = image.load(LOG_THEME_PATH.."CUSTOM/system/option_panel/butt2.png")

optionpanel.x = (480 - optionpanel.img_panel:width()) / 2
optionpanel.y = (272 - optionpanel.img_panel:height()) / 2
optionpanel.w = optionpanel.img_panel:width()
end

function optionpanel.init(text,chunk_yes,chunk_no)
if kernel.isOption == true then return end
if optionpanel.img_panel == nil then optionpanel.load() end
optionpanel.activate()
optionpanel.chSI = chunk_yes
optionpanel.chNO = chunk_no
optionpanel.texto = text
end

function optionpanel.draw()


if optionpanel.activado == false then return end

if optionpanel.desactivar == false then
	optionpanel.trans = optionpanel.trans + 10
else
	optionpanel.trans = optionpanel.trans - 20
end

if optionpanel.trans < 0 then optionpanel.trans = 0 end
if optionpanel.trans > 255 then optionpanel.trans = 255 end


if optionpanel.trans == 0 and optionpanel.desactivar == true then
	if optionpanel.tmpef1 == false then
		optionpanel.tmpef1 = true
	else
		optionpanel.desactivate();
		return 
	end
end

puntero.interactive_type = 0

---- AQUI SE DIBUJA EL CONTENIDO DEL OPTION PANEL
local btt1x = optionpanel.x + 48
local btt1y = optionpanel.y + 115

local btt2x = optionpanel.x + 48 + 87 + 25
local btt2y = btt1y

optionpanel.img_panel:blend(optionpanel.x,optionpanel.y,optionpanel.trans)
screen.print(optionpanel.x + 15,optionpanel.y + 15,optionpanel.texto,0.6,color.new(20,20,20,optionpanel.trans),color.new(255,255,255,optionpanel.trans - 50),"left",optionpanel.w - 30)

optionpanel.img_btt1:blend(btt1x,btt1y,optionpanel.trans)
optionpanel.img_btt1:blend(btt2x,btt2y,optionpanel.trans)

--[[
if controls.press(control.config["back"]) then
	optionpanel.focoIn = 2
	optionpanel.desactivar = true
end
]]--

if optionpanel.desactivar == true then return end

if controls.press(control.config["home"]) then
	--home.run()
end

if controls.press("select") then
	home.run()
end

if controls.press("l") then
	optionpanel.focoIn = 2
end

if controls.press("r") then
	optionpanel.focoIn = 1
end

if puntero.isOver(btt1x,btt1y,87,23) then
	puntero.overOn("link")
	optionpanel.focoIn = 1
	optionpanel.img_btt2:blend(btt1x,btt1y,optionpanel.trans)
	
	if controls.press(control.config["select"]) then
		optionpanel.desactivar = true
		controls.read()
	end
end

if puntero.isOver(btt2x,btt2y,87,23) then
	puntero.overOn("link")
	optionpanel.focoIn = 2
	optionpanel.img_btt2:blend(btt2x,btt2y,optionpanel.trans)
	
	if controls.press(control.config["select"]) then
		optionpanel.desactivar = true
		controls.read()
	end
end

screen.print(btt1x + 32,btt1y + 7,getText("si"),0.65,color.new(20,20,20,optionpanel.trans),color.new(255,255,255,optionpanel.trans - 55))
screen.print(btt2x + 32,btt2y + 7,getText("no"),0.65,color.new(20,20,20,optionpanel.trans),color.new(255,255,255,optionpanel.trans - 55))

end

function optionpanel.activate()
controls.read()
if kernel.isPopup == true then
	popup.desactivar = true
end

optionpanel.trans = 0
optionpanel.focoIn = 2 -- Establece el foco en la opcion NO
optionpanel.activado = true
optionpanel.desactivar = false
kernel.isOption = true
control.lock(optionpanel.llave)
end

function optionpanel.desactivate()
controls.read()
optionpanel.trans = 0
optionpanel.activado = false
optionpanel.desactivar = false
kernel.isOption = false
optionpanel.tmpef1 = false
control.unlock()

if optionpanel.focoIn == 1 then
	if optionpanel.chSI ~= nil then
		assert(loadstring(optionpanel.chSI))();
	end
else
	if optionpanel.chNO ~= nil then
		assert(loadstring(optionpanel.chNO))();
	end
end
end

function optionpanel.free()
	--- Codigo para la liberacion de memoria del panel de opciones (si no) modo "proceso paralelo"
end