portal.opciones = {}
portal.icon_path = "ms0:/FISHELL/SRC/PORTAL/CFG_SYSTEM/src/icons"
portal.img_back = image.load("ms0:/FISHELL/SRC/PORTAL/CFG_SYSTEM/src/background.png")
portal.img_back2 = image.load("ms0:/FISHELL/SRC/PORTAL/CFG_SYSTEM/src/background2.png")
portal.img_table = image.load("ms0:/FISHELL/SRC/PORTAL/CFG_SYSTEM/src/table.png")
portal.img_tableb = image.load("ms0:/FISHELL/SRC/PORTAL/CFG_SYSTEM/src/tableb.png")
portal.img_icon_unk = image.load("ms0:/FISHELL/SRC/PORTAL/CFG_SYSTEM/src/icons/unknown.png")

portal.elements = {}
table.insert(portal.elements,{name = getText("idioma del shell",ID003PC) , icon = nil , type = "chunk" , chunk = "portal.selectLanguage()" , value = LOG_LENGUAGE }) --- elemento textfield
table.insert(portal.elements,{name = "Joy Stick" , icon = nil , type = "swich" , value = cfg.joystick_enabled })
table.insert(portal.elements,{name = getText("usb persistente",ID003PC) , icon = nil , type = "swich" , value = cfg.usbpersistent }) --- elemento textfield
table.insert(portal.elements,{name = getText("liberar ram automaticamente",ID003PC), icon = nil , type = "swich" , value = true }) --- elemento textfield
table.insert(portal.elements,{name = getText("segundos por liberacion",ID003PC) , icon = nil , type = "text" , value = cfg.auto_collectgarbage_sec }) --- elemento textfield
table.insert(portal.elements,{name = getText("full fishbar",ID003PC) , icon = nil , type = "swich" , value = cfg.draw_full_fishbar }) --- elemento textfield
table.insert(portal.elements,{name = getText("velocidad del cpu",ID003PC) , icon = nil , type = "text" , value = cfg.cpu }) --- elemento textfield
table.insert(portal.elements,{name = getText("efecto onda descktop",ID003PC) , icon = nil , type = "swich" , value = cfg.wave }) --- elemento textfield
table.insert(portal.elements,{name = getText("efecto onda fishbar",ID003PC) , icon = nil , type = "swich" , value = cfg.fishbar_wave })
table.insert(portal.elements,{name = getText("aviso umd",ID003PC) , icon = nil , type = "swich" , value = cfg.umd_alert  }) --- elemento textfield

portal.page = 1
portal.foco = 1
portal.font = font.load("ms0:/FISHELL/FONTS/fish_2.pgf")
portal.totalpages = #portal.elements
portal.scrollbar = scrollbar.new(472,0,272,portal.page,portal.totalpages)

function portal.draw(trans)
	portal.img_screen:blit(0,0)
	portal.img_back:blend(0,0,trans - 15)
	portal.img_back2:blend(0,0,trans - 70)
	
	for i = 0,7 do
		local j = i + portal.page
		local x = 0
		local y = 0 + (i * 39)
		
		if portal.elements[j] == nil then break end
		
		portal.showTable(j,x,y,trans)
	end
	
	scrollbar.setVal(portal.scrollbar,portal.foco,portal.totalpages)
	scrollbar.draw(portal.scrollbar,trans)
	
	system.runPortalKernel({ home = false })
	
	if trans ~= 255 then return end
	
	if control.press("select") then
		if portal.elements[portal.foco].type == "swich"  then
			if portal.elements[portal.foco].value == true then
				portal.elements[portal.foco].value = false
			else
				portal.elements[portal.foco].value = true
			end
		end
		
		if portal.elements[portal.foco].type == "chunk"  then
			assert(loadstring(portal.elements[portal.foco].chunk))();
		end
	end
	
	if control.press("back") then
		portal.saveConfiguration()
		portal.open = false
	end
	
	if control.press("up") then
		portal.foco = portal.foco - 1
		if portal.foco < 1 then portal.foco = 1 end
		
		if portal.foco < portal.page + 1 then portal.page = portal.foco - 1 end
	end
	
	if control.press("down") then
		portal.foco = portal.foco + 1
		if portal.foco > portal.totalpages then portal.foco = portal.totalpages end
		
		if portal.foco > portal.page + 5 then
			portal.page = portal.foco - 5
			if portal.page + 6 >= portal.totalpages then portal.page = portal.totalpages - 6 end
		end
	end
	
	if portal.page < 1 then portal.page = 1 end
	if portal.page > portal.totalpages then portal.page = portal.totalpages end
	
end

function portal.showTable(i,x,y,trans)
	if portal.foco == i then
		draw.fillrect(x,y,480,40,color.new(255,255,255,trans))
		portal.img_tableb:blend(x,y,trans)
	else
		portal.img_table:blend(x,y,trans)
	end
	
	if portal.elements[i].icon == nil then
		portal.img_icon_unk:blend(x + 5,y + 5,trans)
	else
		portal.elements[i].icon:blend(x + 5,y + 5,trans)
	end
	
	screen.print(portal.font,x + 40, y + 15,portal.elements[i].name,0.55,color.new(255,255,255,trans),color.new(255,255,255,trans))
	screen.print(portal.font,x + 40, y + 15,portal.elements[i].name,0.55,color.new(255,255,255,trans),color.new(255,255,255,trans))
	
	if portal.elements[i].type == "swich" then
		local texto = "["..string.upper(getText("desactivado")).."]"
		
		if portal.elements[i].value == true then
			texto = "["..string.upper(getText("activado")).."]"
		end
		
		if portal.elements[i].value == true then
			screen.print(460,y + 16,texto,0.5,color.new(255,255,255,trans),0x0,"right")
		else
			screen.print(460,y + 16,texto,0.5,color.new(200,200,200,trans),color.new(0,0,0,trans - 90),"right")
		end

	else
		screen.print(460,y + 16,portal.elements[i].value,0.5,color.new(255,255,255,trans),0x0,"right")
	end

end

function portal.saveConfiguration()

	local resp = os.message(getText("desea guardar cambios?",ID003PC),1) 
	
	if resp == 0 then 
		return
	end
	
	system.printLabel("03",getText("cargando"));

	--portal.elements[1]
	if CFGW == nil then
		system.dofile("ms0:/FISHELL/SRC/DOC/cfgw.lue")
	end
	
	CFGW.write("ms0:/FISHELL/INSTALL/install.ini","INSTALL_LENGUAGE",tostring("\""..portal.elements[1].value.."\""))
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.joystick_enabled",tostring(portal.elements[2].value))
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.usbpersistent",tostring(portal.elements[3].value))
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.auto_collectgarbage",tostring(portal.elements[4].value))
	--- Pendiente el index 5
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.draw_full_fishbar",tostring(portal.elements[6].value))
	--- Pendiente el index 7
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.wave",tostring(portal.elements[8].value))
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.fishbar_wave",tostring(portal.elements[9].value))
	CFGW.write(LOG_PATH.."CUSTOM/CFG.ini","cfg.umd_alert",tostring(portal.elements[10].value))
	system.closeLabel()
	
	portal.isModified = true
	
end

function portal.selectLanguage()
	local lang = system.selectLanguage()
	
	if lang ~= nil then
		portal.elements[1].value = lang
	end
end

system.closeLabel()
portal.img_screen = screen.toimage()

for i = 0,255,12 do
	portal.draw(i)
end

while portal.open do
	portal.draw(255)
end

for i = 255,-12,-12 do
	portal.draw(i)
end

if kernel ~= nil then kernel.postImage(portal.img_screen) end

if portal.isModified == true and os.message(getText("para guardar cambios reiniciar",ID003PC),1) == 1 then
	system.reloadSystem()
end

return nil